#include "testApp.h"

//--------------------------------------------------------------
void testApp::setup(){
	
	// set background color to be white: 
	ofBackground(255, 255, 255);
	
	// this prevents banding on mac (vertical sync)
	ofSetVerticalSync(true);
	
	
	// load the image from the data folder
	myPicture.loadImage("test.png");
	
	// set the image type to be grayscale (1 byte per pixel)
	myPicture.setImageType(OF_IMAGE_GRAYSCALE);
	
	// allocate pixels and texture for this image. 
	width = myPicture.width;
	height = myPicture.height;
	pixels = new unsigned char [width * height];
	texture.allocate(width, height, GL_LUMINANCE);
	
	// get a pointer to the image data:
	unsigned char * pixelsFromImage = myPicture.getPixels();
	
	// copy the pixels in and upload
	for (int i = 0; i < width; i++){
		for (int j = 0; j < height; j++){
			
			int pixIndex = j * width + i;
			pixels[pixIndex] = pixelsFromImage[pixIndex];
		}
	}
	
	texture.loadData(pixels, width, height, GL_LUMINANCE);
	
}

//--------------------------------------------------------------
void testApp::update(){
	
	unsigned char * pixelsFromImage = myPicture.getPixels();
	// copy the pixels in and upload
	for (int i = 0; i < width; i++){
		for (int j = 0; j < height; j++){
			
			int pixIndex = j * width + i;
			int pixSource = (j + (int)ofRandom(-mouseY, mouseY)) * width + (i +  (int)ofRandom(-mouseX, mouseX));
			if (pixSource < 0) pixSource = 0;
			if (pixSource >= width*height) pixSource = width*height-1;
			pixels[pixIndex] = pixelsFromImage[pixSource];
			
		}
	}
	
	texture.loadData(pixels, width, height, GL_LUMINANCE);
}

//--------------------------------------------------------------
void testApp::draw(){
	

	// when we draw, the drawing color "tints" the drawing, so white is best for image
	// ie, white = no tint.
	ofSetColor(255, 255, 255);
	myPicture.draw(0,0);
	
	texture.draw(myPicture.width, 0);
	
}

//--------------------------------------------------------------
void testApp::keyPressed(int key){

}

//--------------------------------------------------------------
void testApp::keyReleased(int key){

}

//--------------------------------------------------------------
void testApp::mouseMoved(int x, int y ){

}

//--------------------------------------------------------------
void testApp::mouseDragged(int x, int y, int button){

}

//--------------------------------------------------------------
void testApp::mousePressed(int x, int y, int button){

}

//--------------------------------------------------------------
void testApp::mouseReleased(int x, int y, int button){

}

//--------------------------------------------------------------
void testApp::windowResized(int w, int h){

}

